import sys

import xbmc
import xbmcgui
import xbmcplugin

from resources.lib.const import STRINGS, ROUTE
from resources.lib.kodilogging import logger
from resources.lib.utils.kodiutils import go_to_plugin_url, replace_plugin_url, set_resolved_url
from resources.lib.utils.url import Url


class Router:
    @staticmethod
    def go(route, query=''):
        logger.debug('Going to route: %s' % route)
        go_to_plugin_url(STRINGS.QUERY.format(route, query))

    @staticmethod
    def get_url(_route, **kwargs):
        return STRINGS.QUERY.format(_route, Url.encode(kwargs))

    @staticmethod
    def get_url_api(route, url):
        return STRINGS.QUERY.format(route, Router.encode_url(url))

    @staticmethod
    def get_url_command(command):
        return STRINGS.QUERY.format(ROUTE.COMMAND, Url.encode({
            'command': command
        }))

    # After redirect it also resets KODI path history a.k.a "back" action takes you to root path
    @staticmethod
    def replace_route(handle, route):
        xbmcplugin.endOfDirectory(handle, cacheToDisc=False)
        logger.debug('Replacing path with {}'.format(route))
        replace_plugin_url(route)

    @staticmethod
    def set_resolved_url(handle, li=xbmcgui.ListItem(path='Invalid URL')):
        set_resolved_url(handle, li)

    @staticmethod
    def encode_url(url):
        return Url.encode({
            'url': url
        })

    @staticmethod
    def go_url(route, url):
        Router.go(route, Router.encode_url(url))

    # TODO: Make it work!
    @staticmethod
    def exit():
        xbmc.executebuiltin("xbmc.ActivateWindow(Home)")

    @staticmethod
    def get_media(media_type, render_type, url):
        return router.get_url(ROUTE.GET_MEDIA,
                              media_type=media_type,
                              render_type=render_type,
                              url=url)




router = Router()
